// outputs webpack stats to console if there are no errors or warnings

"use strict";

exports.__esModule = true;
exports["default"] = notify_stats;
function error(error) {
	// BELLs when something goes wrong!
	console.log("\u0007" + error);
}

function warning(warning) {
	console.log(warning);
}

function notify_stats(stats, json) {
	// if there were any errors
	if (json.errors.length > 0) {
		return json.errors.forEach(error);
	}

	// if there were any warnings
	if (json.warnings.length > 0) {
		json.warnings.forEach(warning);
	}

	// if it's ok
	console.log(stats.toString({
		chunks: false,
		colors: true
	}));
}

module.exports = exports["default"];
//# sourceMappingURL=notify stats.js.map